---
title: PostgreSQL JDBC Driver 42.2.16 Released
date: 2020-08-20 15:10:04 +0000
categories:
  - new_release
version: 42.2.16
---
**Notable changes**

### Known issues
- The driver returns enum and jsonb arrays elements are returned as PGobject instances (fixed in 42.2.17)

### Fixed
- Arrays sent in binary format are now sent as 1 based. This was a regression for multi-dimensional arrays as well as text/varchar, oid and bytea arrays. 
Since 42.2.0 single dimensional arrays were stored 0 based. They are now sent 1 based which is the SQL standard, and the default 
for Postgres when sent as strings such as '{1,2,3}'.
Fixes [issue 1860](https://github.com/pgjdbc/pgjdbc/issues/1860) in [PR 1863](https://github.com/pgjdbc/pgjdbc/pull/1863).

<!--more-->

**Commits by author**

Brett Okken (3):

* Binary array index [PR 1863](https://github.com/pgjdbc/pgjdbc/pull/1863) [a0babeb3](https://github.com/pgjdbc/pgjdbc/commit/a0babeb3461a32788cced6f8641e4e2a89df472d)
* fix: preserve unquoted unicode whitespace in array literals [PR 1266](https://github.com/pgjdbc/pgjdbc/pull/1266) [e8923c71](https://github.com/pgjdbc/pgjdbc/commit/e8923c71597f844f07ef1b123d704d0a3b332a38)

Dave Cramer (3):

* move fix to correct place and remove duplicate [PR 1859](https://github.com/pgjdbc/pgjdbc/pull/1859) [ffd428f1](https://github.com/pgjdbc/pgjdbc/commit/ffd428f1e0ceeeff1f2c7835a8e165e055e4bf77)

Sehrope Sarkuni (1):

* fix: Remove unused .ratignore [PR 1857](https://github.com/pgjdbc/pgjdbc/pull/1857) [aa4cb6d8](https://github.com/pgjdbc/pgjdbc/commit/aa4cb6d81c83ee7ce4d246b7113eb717b4179cf8)

Vladimir Sitnikov (3):

* docs: add release notes for 42.2.15 [PR 1858](https://github.com/pgjdbc/pgjdbc/pull/1858) [0c162bc0](https://github.com/pgjdbc/pgjdbc/commit/0c162bc036072d46f3a6adf2cc7bd66fe304c012)
draderaws (1):

* Fix header on existing Parameter Status doc page, and include entry in the index html page. [PR 1845](https://github.com/pgjdbc/pgjdbc/pull/1845) [99623077](https://github.com/pgjdbc/pgjdbc/commit/99623077ed3ced321937f21323f33c674a9a5a31)

<a name="contributors_{{ page.version }}"></a>
### Contributors to this release

We thank the following people for their contributions to this release.

[Brett Okken](https://github.com/bokken)  
[Dave Cramer](davec@postgresintl.com)  
[draderaws](https://github.com/draderaws)  
[Sehrope Sarkuni](https://github.com/sehrope)  
[Vladimir Sitnikov](https://github.com/vlsi)  
