---
title: PostgreSQL JDBC Driver 42.2.17 Released
date: 2020-10-09 14:24:57 +0000
categories:
  - new_release
version: 42.2.17
---
**Notable changes**


### Changed
- Change default of gssEncMode to ALLOW. PostgreSQL can deal with PREFER but there are cloud providers that did not implement the protocol properly. Libpq gets around this by checking for a GSS credential cache before attempting the connection. This is possible in JDK 8 and up, but not JDK6, or JDK7 fixes Issue #1868 [PR #1913](https://github.com/pgjdbc/pgjdbc/pull/1913)

### Added
- Add smallserial metadata [PR #899(https://github.com/pgjdbc/pgjdbc/pull/899)

### Fixed
- Avoid NullPointerException when receiving PGbox, PGcircle, PGline, PGlseg, PGpath, PGpoint, PGpolygon, and PGmoney [PR 1873] (https://github.com/pgjdbc/pgjdbc/pull/1873)..
- The driver returns enum and jsonb arrays elements as String objects (like in 42.2.14 and earlier versions) [PR 1879](https://github.com/pgjdbc/pgjdbc/pull/1879). 
- PgTokenizer was ignoring last empty token [PR #1882](https://github.com/pgjdbc/pgjdbc/pull/1882)
- Remove osgi from karaf fixes Issue #1891 [PR #1902](https://github.com/pgjdbc/pgjdbc/pull/1902)


<!--more-->

**Commits by author**

Dave Cramer (5):

* fix: PgTokenizer was ignoring last empty token [PR 1882](https://github.com/pgjdbc/pgjdbc/pull/1882) [a6e83342](https://github.com/pgjdbc/pgjdbc/commit/a6e833429303acf330b9ff512df55e1c3c158ee2)
* fix checkstyle [PR 1888](https://github.com/pgjdbc/pgjdbc/pull/1888) [70b02c55](https://github.com/pgjdbc/pgjdbc/commit/70b02c55233bec6ea87286b4fb80ac60a0ebd76f)
* fix: handle smallserial correctly fixes [PR 1897](https://github.com/pgjdbc/pgjdbc/pull/1897) (#1899) [d4a4b2d6](https://github.com/pgjdbc/pgjdbc/commit/d4a4b2d643547e89fc349847d8d0c098108270ab)
* fix:remove osgi from karaf fixes Issue [PR 1891](https://github.com/pgjdbc/pgjdbc/pull/1891) (#1902) [0c2858e9](https://github.com/pgjdbc/pgjdbc/commit/0c2858e9cabb1209c2b30cf03c07a30b8051cf4c)
* Change default of gssEncMode to ALLOW. PostgreSQL can deal with PREFER but there are cloud providers that did not implement the protocol properly [14c4173c](https://github.com/pgjdbc/pgjdbc/commit/14c4173ca6719a8dea8539621583d785bbd8f632)

Jorge Solorzano (1):

* feat: add smallserial metadata [PR 899](https://github.com/pgjdbc/pgjdbc/pull/899) [05403bd0](https://github.com/pgjdbc/pgjdbc/commit/05403bd02ed40e4f029f19800b32af9f96637e34)

Vladimir Sitnikov (8):

* fix: handle nulls when the following clasess are used: PGbox, PGcircle, PGline, PGlseg, PGpath, PGpoint, PGpolygon, and PGmoney [c745f4e5](https://github.com/pgjdbc/pgjdbc/commit/c745f4e549b119b8332ef48bbc8b8525ccba0f21)
* chore: fix compileJava7 and compileJava6 [0308ffca](https://github.com/pgjdbc/pgjdbc/commit/0308ffcafa49271d1dabd001404b955c5e8bbe28)
* chore: run GitHub actions when branch name has slash [433817d6](https://github.com/pgjdbc/pgjdbc/commit/433817d606c42e897ee4b37baf7b50eda5ab3356)
* chore: seed build cache only when credentials exist (==skip on forks) [eec708a8](https://github.com/pgjdbc/pgjdbc/commit/eec708a80ad17f5a17bba5cdbcdcb640b094a965)
* test: add GitHub CI for testing source distribution [44d0923f](https://github.com/pgjdbc/pgjdbc/commit/44d0923fa85e159ac937277767b4dfe2a67df28c)
* test: add tests for enum, json, and jsonb array [1bec4022](https://github.com/pgjdbc/pgjdbc/commit/1bec402208eef17fd81f5dd7cca1d1a36e1466da)
* fix: make enum, json, and jsonb array result classes to be the same as 42.2.14 and earlier [PR 1876](https://github.com/pgjdbc/pgjdbc/pull/1876) [41855018](https://github.com/pgjdbc/pgjdbc/commit/41855018a0371ea6c36d1c88e3a33402f44f53eb)
* fix: avoid removal type annotations on "this" so the source archive is buildable [832bf21c](https://github.com/pgjdbc/pgjdbc/commit/832bf21c3ac37691dc71f6ee6bc1e3da34c7d746)

<a name="contributors_{{ page.version }}"></a>
### Contributors to this release

We thank the following people for their contributions to this release.

[Dave Cramer](davec@postgresintl.com)  
[Jorge Solorzano](https://github.com/jorsol)  
[Vladimir Sitnikov](https://github.com/vlsi)  
